<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Includes</title>

    <link rel="stylesheet" href="/en/latestcss/core.css">
    <link rel="stylesheet" href="/en/latestcss/getstarted.css">
    <link rel="shortcut icon" href="/en/latestcss/images/saltStack_favIcon_32x32.png">

</head>
<body>

<nav id="globalNavbar" class="navbar navbar-default navbar-inverse navbar-fixed-top" role="navigation">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="http://saltstack.com/" target="_blank"><img src="/en/latestcss/images/saltstack.svg" height="40px" width="170px" class="nolightbox"></a>
        </div>
        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                <li><a href="/en/latest">Documentation</a></li>
                <li><a href="/en/getstarted/">Tutorials</a></li>
                <li><a href="/en/latestcontents.html">Reference Guide</a></li>
                <li><a href="https://repo.saltstack.com">Downloads</a></li>
                <li><a href="/en/latesttopics/development/">Develop</a></li>
            </ul>
        </div>
    </div>
</nav>

<div class="jumbotron">

    <div class="row row-centered">
        <div class="col-md-9 col-centered">
            <h1>SaltStack Configuration Management</h1>

            <h3>Get Started Tutorial</h3>

        </div>
    </div>
    <!--<div class="gs-top-nav">
        <a href="/en/getstarted/getstarted/index.html">Back to Get Started <i class="glyphicon glyphicon-arrow-left"></i></a><br>
        <a href="/en/getstarted">Back to Documentation <i class="glyphicon glyphicon-arrow-left"></i></a>
    </div>-->
</div>







<div class="container">
    <div class="row">
        <div class="col-md-12">
            <ol class="progtrckr" data-progtrckr-steps="7">
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/index.html">Introduction</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/functions.html">Functions</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/config/pillar.html">Pillar</a>
                </li>
                
                
                
                <li class="progtrckr-done">Includes</li>
                
                
                
                
                
                
                
                
                
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/config/requisites.html">Ordering & Requisites</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/config/jinja.html">Jinja</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/config/files.html">Manage Files</a>
                </li>
                
                
            </ol>
        </div>
    </div>

    <div class="row">
        <div class="col-md-1"></div>
        <div class="col-md-10">

            

            <h1>Includes</h1>

            <div class="section gs-overview">

                
                <p class="p gs-overview-sub"><span class="ph">You'll learn how to:</span></p>

                <ul class="ul">
                    
                    <li class="progtrckr-done">Reuse Salt states</li>
                    
                    <li class="progtrckr-done">Understand when to use includes</li>
                    
                </ul>
                

                
                <p class="p gs-overview-sub gs-time"><span class="ph">
                              Estimated time: 5 minutes</span>&nbsp;<i
                        class="glyphicon glyphicon-time"></i>
                </p>
                

                
                <p class="p gs-overview-sub gs-difficulty-1"><span class="ph">Difficulty</span>:&nbsp;
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                </p>
                
            </div>
            

            <div class="section sidebar">
<h4 id="salt-state-trees">Salt State Trees</h4>
<p>Salt state files are organized into a directory tree, called the Salt state tree, in the <code>/srv/salt/</code> directory. Any new states that you create should be placed in this directory. To change this location, update the file_roots settings in <code>/etc/salt/master</code>.</p>
</div>
<p>To keep your Salt states modular and reusable, each configuration task should be described only once in your Salt state tree (<a href="http://en.wikipedia.org/wiki/Don%27t_repeat_yourself">D.R.Y</a>). If you need to use the same configuration task in multiple places, you can use in include.</p>
<p>Using an include is simple. At the top of your state file (outside of any ID), add an include using the following format:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">include:</span>
  <span class="kw">-</span> sls1 
  <span class="kw">-</span> sls2</code></pre>
<p>Where <code>sls1</code> and <code>sls2</code> are the names of the SLS files that you want to include. Note that you don’t need to include the .sls extension.</p>
<p>If the Salt state file that you want to include is in a subdirectory in your Salt state tree, use a dot (<strong>.</strong>) as a directory separator:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">include:</span>
  <span class="kw">-</span> dir.sls1 </code></pre>
<p>Included Salt states are inserted at the top of the current file and are processed first.</p>
<h2 id="example">Example</h2>
<p>Remember this Salt state from earlier in this guide?</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">sync directory using lftp:</span>
  <span class="fu">cmd.run:</span>
    <span class="kw">-</span> <span class="fu">name:</span> lftp -c &quot;open -u {{ pillar[&#39;ftpusername&#39;] }},{{ pillar[&#39;ftppassword&#39;] }}
           <span class="kw">-</span><span class="fu">p 22 sftp:</span>//example.com;mirror -c -R /local /remote&quot;</code></pre>
<p>This Salt state depends on the lftp executable, so it might be a good idea to create another Salt state to make sure that lftp is installed. We can then combine both states using an include.</p>
<p><code>srv/salt/lftp.sls</code>:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">install lftp:</span>
  <span class="fu">pkg.installed:</span>
    <span class="kw">-</span> <span class="fu">name:</span> lftp</code></pre>
<p><code>srv/salt/dir-sync.sls</code>:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">include:</span>
  <span class="kw">-</span> lftp

<span class="fu">sync directory using lftp:</span>
  <span class="fu">cmd.run:</span>
    <span class="kw">-</span> <span class="fu">name:</span> lftp -c &quot;open -u {{ pillar[&#39;ftpusername&#39;] }},{{ pillar[&#39;ftppassword&#39;] }}
           <span class="kw">-</span><span class="fu">p 22 sftp:</span>//example.com;mirror -c -R /local /remote&quot;</code></pre>
<p>The advantage to using an include is that you can use the <code>lftp.sls</code> Salt state elsewhere to install lftp without syncing these directories.</p>
<h2 id="why-not-just-include-using-the-top-file">Why not just include using the Top File?</h2>
<p>Instead of having one Salt state include another:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">include:</span>
  <span class="kw">-</span> sls1

<span class="fu">install a useful package:</span>
  <span class="fu">pkg.installed:</span>
    <span class="kw">-</span> <span class="fu">name:</span> cowsay</code></pre>
<p>You could optionally put each in their own Salt state file and then include both using the top file:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">base:</span>
  <span class="fu">&#39;web*&#39;:</span>
    <span class="kw">-</span> sls1
    <span class="kw">-</span> sls2</code></pre>
<p>If a Salt state always needs some other state, then using an include is a better choice. If only some systems should receive both Salt states, including both states in the Top file gives you the flexibility to choose which systems receive each.</p>


            <br>
            
            <a href="/en/getstarted/config/pillar.html">
                <button type="button" class="btn btn-secondary"><span
                        class="glyphicon glyphicon-chevron-left"></span> Previous
                </button>
            </a>
            

            
            <a href="/en/getstarted/config/requisites.html">
                <button type="button" class="btn btn-primary btn-right">
                    Next <span class="glyphicon glyphicon-chevron-right"></span></button>
            </a>
            

        </div>
        <div class="col-md-1"></div>
    </div>
    <div class="footer">
    <p>© 2020 SaltStack | <a href="http://saltstack.com/privacy-policy" target="_blank">Privacy Policy</a></p>
</div>
</div>

<script type="text/javascript" src="/en/latestjs/core-min.js"></script>



<!--analytics-->
<script type="text/javascript" language="javascript">llactid=23943</script>
<script type="text/javascript" language="javascript" src="https://trackalyzer.com/trackalyze_secure.js"></script>

<script>
          var _gaq = _gaq || [];
          var pluginUrl = '//www.google-analytics.com/plugins/ga/inpage_linkid.js';
          _gaq.push(['_require', 'inpage_linkid', pluginUrl]);
          _gaq.push(['_setAccount', 'UA-26984928-1']);
          _gaq.push(['_setDomainName', 'saltstack.com']);
          _gaq.push(['_trackPageview']);

          (function() {
              var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
              ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
              var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();

</script>

</body>
</html>